Index: configure.ac
===================================================================
--- configure.ac	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ configure.ac	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -155,4 +155,6 @@
 	src/Actions/unittests/Makefile
 	src/Descriptors/unittests/Makefile
+	src/Helpers/unittests/Makefile
+	src/LinearAlgebra/unittests/Makefile
 	src/Patterns/unittests/Makefile
 ])
Index: src/Actions/unittests/Makefile.am
===================================================================
--- src/Actions/unittests/Makefile.am	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ src/Actions/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -41,5 +41,5 @@
 	ActionSequenceUnitTest.cpp \
 	ActionSequenceUnitTest.hpp
-ActionSequenceUnitTest_LDADD = ${UILIBS} ${ALLLIBS}
+ActionSequenceUnitTest_LDADD = ${ALLLIBS}
 
 AtomsCalculationUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
Index: src/Helpers/unittests/InfoUnitTest.cpp
===================================================================
--- src/Helpers/unittests/InfoUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/Helpers/unittests/InfoUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,63 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * InfoUnitTest.cpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+#include <stdio.h>
+
+#include "Helpers/Info.hpp"
+#include "Helpers/Log.hpp"
+
+#include "InfoUnitTest.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( InfoTest );
+
+
+void InfoTest::setUp()
+{
+};
+
+
+void InfoTest::tearDown()
+{
+  logger::purgeInstance();
+};
+
+/** UnitTest for FunctionTest().
+ */
+void InfoTest::FunctionTest()
+{
+  const char *msg = __func__;
+  class Info test(msg);
+
+  CPPUNIT_ASSERT_EQUAL( msg , test.FunctionName );
+  CPPUNIT_ASSERT_EQUAL( 1, test.verbosity );
+};
Index: src/Helpers/unittests/InfoUnitTest.hpp
===================================================================
--- src/Helpers/unittests/InfoUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/Helpers/unittests/InfoUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,32 @@
+/*
+ * InfoUnitTest.hpp
+ *
+ *  Created on: Nov 25, 2009
+ *      Author: heber
+ */
+
+#ifndef INFOUNITTEST_HPP_
+#define INFOUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class info;
+
+/********************************************** Test classes **************************************/
+
+class InfoTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( InfoTest) ;
+    CPPUNIT_TEST ( FunctionTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+      void setUp();
+      void tearDown();
+      void FunctionTest();
+
+private:
+
+};
+
+#endif /* INFOUNITTEST_HPP_ */
Index: src/Helpers/unittests/Makefile.am
===================================================================
--- src/Helpers/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/Helpers/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,28 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+AM_CPPFLAGS = ${BOOST_CPPFLAGS}
+
+TESTS = \
+  InfoUnitTest
+
+
+check_PROGRAMS = $(TESTS) 
+noinst_PROGRAMS = $(TESTS)
+
+BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) $(BOOST_FILESYSTEM_LIB) $(BOOST_SYSTEM_LIB) $(BOOST_THREAD_LIB)
+HELPERSLIBS = \
+	../../Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB)
+
+InfoUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	InfoUnitTest.cpp \
+	InfoUnitTest.hpp 
+InfoUnitTest_LDADD = ${HELPERSLIBS}
+
+
+#AUTOMAKE_OPTIONS = parallel-tests
Index: src/LinearAlgebra/unittests/Makefile.am
===================================================================
--- src/LinearAlgebra/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,42 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+AM_CPPFLAGS = ${BOOST_CPPFLAGS}
+
+TESTS = \
+  MatrixContentSymmetricUnitTest \
+  MatrixContentUnitTest \
+  MatrixUnitTest
+
+
+check_PROGRAMS = $(TESTS) 
+noinst_PROGRAMS = $(TESTS)
+
+BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) $(BOOST_FILESYSTEM_LIB) $(BOOST_SYSTEM_LIB) $(BOOST_THREAD_LIB)
+GSLLIBS = \
+	../../LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	../../Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	../../Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB)
+
+MatrixContentSymmetricUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	MatrixContentSymmetricUnitTest.cpp \
+	MatrixContentSymmetricUnitTest.hpp
+MatrixContentSymmetricUnitTest_LDADD = ${GSLLIBS}
+
+MatrixContentUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	MatrixContentUnitTest.cpp \
+	MatrixContentUnitTest.hpp
+MatrixContentUnitTest_LDADD = ${GSLLIBS}
+
+MatrixUnitTest_SOURCES = $(top_srcdir)/src/unittests/UnitTestMain.cpp \
+	MatrixUnitTest.cpp \
+	MatrixUnitTest.hpp
+MatrixUnitTest_LDADD = ${GSLLIBS}
+
+
+#AUTOMAKE_OPTIONS = parallel-tests
Index: src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.cpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,285 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MatrixContentSymmetricUnitTest.cpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "MatrixContentSymmetricUnitTest.hpp"
+
+#include "LinearAlgebra/MatrixContent.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MatrixContentSymmetricTest );
+
+
+void MatrixContentSymmetricTest::setUp()
+{
+  m = new MatrixContent(3,3);
+};
+
+void MatrixContentSymmetricTest::tearDown()
+{
+  delete(m);
+};
+
+/** Unit Test for accessing matrix elements.
+ *
+ */
+void MatrixContentSymmetricTest::AccessTest()
+{
+  // check whether all elements are initially zero
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
+
+  // set
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i*3+j );
+
+  // and check
+  double *ptr = NULL;
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++) {
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->at(i,j) );
+      ptr = m->Pointer(i,j);
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
+    }
+
+  // assignment
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i*3+j );
+  MatrixContent *dest = new MatrixContent(3,3);
+  *dest = *m;
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( dest->at(i,j), m->at(i,j) );
+  delete(dest);
+
+  // out of bounds
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(4,2) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(2,17) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(1024,140040) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,0) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(0,-1) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,-1) );
+};
+
+/** Unit Test for initializating matrices.
+ *
+ */
+void MatrixContentSymmetricTest::InitializationTest()
+{
+  // set zero
+  m->setZero();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
+
+  // set all
+  m->setValue(1.5);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 1.5, m->at(i,j) );
+
+  // set basis
+  m->setIdentity();
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
+
+  // set from array
+  double array[] = { 1., 0., 0.,
+                     0., 1., 0.,
+                     0., 0., 1. };
+  m->setFromDoubleArray(array);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
+
+};
+
+/** Unit Test for copying matrices.
+ *
+ */
+void MatrixContentSymmetricTest::CopyTest()
+{
+  // set basis
+  MatrixContent *dest = NULL;
+  for (int i=0;i<3;i++) {
+    m->setValue(i);
+    dest = new MatrixContent(m);
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( m->at(i,j) , dest->at(i,j) );
+
+    delete(dest);
+  }
+};
+
+/** Unit Test for exchanging rows and columns.
+ *
+ */
+void MatrixContentSymmetricTest::ExchangeTest()
+{
+  // set to 1,1,1,2, ...
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i+1 );
+
+  // swap such that nothing happens
+  m->SwapColumns(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
+
+  // swap two rows
+  m->SwapRows(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 1., m->at(j,i) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 3., m->at(j,i) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 2., m->at(j,i) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+      }
+  // check that op is reversable
+  m->SwapRows(1,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
+
+  // set to 1,2,3,1, ...
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, j+1. );
+
+  // swap such that nothing happens
+  m->SwapRows(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
+
+  // swap two columns
+  m->SwapColumns(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+      }
+  // check that op is reversable
+  m->SwapColumns(0,2);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
+
+
+  // set to 1,2,3, ...
+  MatrixContent *n =  new MatrixContent(3,3);
+  for (int i=0;i<3;i++)
+    for (int j=0;j<3;j++) {
+      m->set(i,j, 3*i+j+1 );
+      n->set(i,j, 3*j+i+1 );
+    }
+  // transpose
+  MatrixContent res = ((const MatrixContent)*m).transpose();
+  CPPUNIT_ASSERT( *n == res );
+  // second transpose
+  res.transpose();
+  CPPUNIT_ASSERT( *m == res );
+  delete n;
+};
+
+/** Unit Test for matrix properties.
+ *
+ */
+void MatrixContentSymmetricTest::PropertiesTest()
+{
+  // is zero
+  m->setZero();
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is positive
+  m->setValue(0.5);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is negative
+  m->setValue(-0.1);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
+
+  // is positive definite
+  double array[] = { 1., 0., 0.,
+                     0., 1., 1.,
+                     0., 0., 1. };
+  m->setFromDoubleArray(array);
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositiveDefinite() );
+
+  //determinant
+  m->setIdentity();
+  CPPUNIT_ASSERT_EQUAL( 1., m->Determinant() );
+
+  m->setZero();
+  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
+
+  m->set( 0, 0, 1.);
+  m->set( 1, 1, 1.);
+  m->set( 2, 1, 1.);
+  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
+  
+  double array2[] = { 2., 0., 1.,
+                     -3., 1., 1.,
+                     1., 5.5, 1. };
+  m->setFromDoubleArray(array2);
+  CPPUNIT_ASSERT_EQUAL( -26.5, m->Determinant() );
+};
Index: src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.hpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,42 @@
+/*
+ * MatrixContentSymmetricUnitTest.hpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+#ifndef MATRIXCONTENTSYMMETRICUNITTEST_HPP_
+#define MATRIXCONTENTSYMMETRICUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class MatrixContent;
+
+/********************************************** Test classes **************************************/
+
+class MatrixContentSymmetricTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( MatrixContentSymmetricTest) ;
+    CPPUNIT_TEST (AccessTest );
+    CPPUNIT_TEST (InitializationTest );
+    CPPUNIT_TEST (CopyTest );
+    CPPUNIT_TEST (ExchangeTest );
+    CPPUNIT_TEST (PropertiesTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+    void setUp();
+    void tearDown();
+
+    void AccessTest();
+    void InitializationTest();
+    void CopyTest();
+    void ExchangeTest();
+    void PropertiesTest();
+
+private:
+    MatrixContent *m;
+};
+
+
+#endif /* MATRIXCONTENTSYMMETRICUNITTEST_HPP_ */
Index: src/LinearAlgebra/unittests/MatrixContentUnitTest.cpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixContentUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixContentUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,267 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MatrixContentUnitTest.cpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "MatrixContentUnitTest.hpp"
+
+#include "LinearAlgebra/MatrixContent.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MatrixContentTest );
+
+
+void MatrixContentTest::setUp()
+{
+  m = new MatrixContent(4,3);
+};
+
+void MatrixContentTest::tearDown()
+{
+  delete(m);
+};
+
+/** Unit Test for accessing matrix elements.
+ *
+ */
+void MatrixContentTest::AccessTest()
+{
+  // check whether all elements are initially zero
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
+
+  // set
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i*3+j );
+
+  // and check
+  double *ptr = NULL;
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++) {
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->at(i,j) );
+      ptr = m->Pointer(i,j);
+      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
+    }
+
+  // assignment
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i*3+j );
+  MatrixContent *dest = new MatrixContent(4,3);
+  *dest = *m;
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( dest->at(i,j), m->at(i,j) );
+  delete(dest);
+
+  // out of bounds
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(5,2) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(2,17) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(1024,140040) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,0) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(0,-1) );
+  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,-1) );
+};
+
+/** Unit Test for initializating matrices.
+ *
+ */
+void MatrixContentTest::InitializationTest()
+{
+  // set zero
+  m->setZero();
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
+
+  // set all
+  m->setValue(1.5);
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( 1.5, m->at(i,j) );
+
+  // set basis
+  m->setIdentity();
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
+
+  // set from array
+  double array[] = { 1., 0., 0.,
+                     0., 1., 0.,
+                     0., 0., 1.,
+                     0., 0., 0. };
+  m->setFromDoubleArray(array);
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
+
+};
+
+/** Unit Test for copying matrices.
+ *
+ */
+void MatrixContentTest::CopyTest()
+{
+  // set basis
+  MatrixContent *dest = NULL;
+  for (int i=0;i<4;i++) {
+    m->setValue(i);
+    dest = new MatrixContent(m);
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( m->at(i,j) , dest->at(i,j) );
+
+    delete(dest);
+  }
+};
+
+/** Unit Test for exchanging rows and columns.
+ *
+ */
+void MatrixContentTest::ExchangeTest()
+{
+  // set to 1,1,1,2, ...
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, i+1 );
+
+  // swap such that nothing happens
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
+
+  // swap two rows
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      switch (i) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
+          break;
+        case 3:
+          CPPUNIT_ASSERT_EQUAL( 4., m->at(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+      }
+  // check that op is reversable
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
+
+  // set to 1,2,3,1, ...
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      m->set(i,j, j+1. );
+
+  // swap such that nothing happens
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
+
+  // swap two columns
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      switch (j) {
+        case 0:
+          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
+          break;
+        case 1:
+          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
+          break;
+        case 2:
+          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
+          break;
+        default:
+          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+      }
+  // check that op is reversable
+  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++)
+      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
+
+
+  // set to 1,2,3,4, ...
+  MatrixContent *n =  new MatrixContent(3,4);
+  for (int i=0;i<4;i++)
+    for (int j=0;j<3;j++) {
+      m->set(i,j, 3*i+j+1 );
+      n->set(j,i, 3*i+j+1 );
+    }
+  // transpose
+  MatrixContent res = ((const MatrixContent)(*m)).transpose();
+  CPPUNIT_ASSERT( *n == res );
+  // second transpose
+  MatrixContent res2 = ((const MatrixContent)res).transpose();
+  CPPUNIT_ASSERT( *m == res2 );
+  delete n;
+};
+
+/** Unit Test for matrix properties.
+ *
+ */
+void MatrixContentTest::PropertiesTest()
+{
+  // is zero
+  m->setZero();
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is positive
+  m->setValue(0.5);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
+
+  // is negative
+  m->setValue(-0.1);
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
+  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
+  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
+
+  // is positive definite
+  CPPUNIT_ASSERT_EQUAL( false, m->IsPositiveDefinite() );
+};
Index: src/LinearAlgebra/unittests/MatrixContentUnitTest.hpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixContentUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixContentUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,42 @@
+/*
+ * MatrixContentUnitTest.hpp
+ *
+ *  Created on: Jan 8, 2010
+ *      Author: heber
+ */
+
+#ifndef MATRIXCONTENTUNITTEST_HPP_
+#define MATRIXCONTENTUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class MatrixContent;
+
+/********************************************** Test classes **************************************/
+
+class MatrixContentTest : public CppUnit::TestFixture
+{
+    CPPUNIT_TEST_SUITE( MatrixContentTest) ;
+    CPPUNIT_TEST (AccessTest );
+    CPPUNIT_TEST (InitializationTest );
+    CPPUNIT_TEST (CopyTest );
+    CPPUNIT_TEST (ExchangeTest );
+    CPPUNIT_TEST (PropertiesTest );
+    CPPUNIT_TEST_SUITE_END();
+
+public:
+    void setUp();
+    void tearDown();
+
+    void AccessTest();
+    void InitializationTest();
+    void CopyTest();
+    void ExchangeTest();
+    void PropertiesTest();
+
+private:
+    MatrixContent *m;
+};
+
+
+#endif /* MATRIXCONTENTUNITTEST_HPP_ */
Index: src/LinearAlgebra/unittests/MatrixUnitTest.cpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixUnitTest.cpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,364 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * MatrixUnitTest.cpp
+ *
+ *  Created on: Jul 7, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <cmath>
+
+#include "MatrixUnitTest.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/RealSpaceMatrix.hpp"
+#include "Exceptions/NotInvertibleException.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MatrixUnittest );
+
+void MatrixUnittest::setUp(){
+  zero = new RealSpaceMatrix();
+  for(int i =NDIM;i--;) {
+    for(int j =NDIM;j--;) {
+      zero->at(i,j)=0.;
+    }
+  }
+  one = new RealSpaceMatrix();
+  for(int i =NDIM;i--;){
+    one->at(i,i)=1.;
+  }
+  full=new RealSpaceMatrix();
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      full->at(i,j)=1.;
+    }
+  }
+  diagonal = new RealSpaceMatrix();
+  for(int i=NDIM;i--;){
+    diagonal->at(i,i)=i+1.;
+  }
+  perm1 = new RealSpaceMatrix();
+  perm1->column(0) = unitVec[0];
+  perm1->column(1) = unitVec[2];
+  perm1->column(2) = unitVec[1];
+
+
+  perm2 = new RealSpaceMatrix();
+  perm2->column(0) = unitVec[1];
+  perm2->column(1) = unitVec[0];
+  perm2->column(2) = unitVec[2];
+
+  perm3 = new RealSpaceMatrix();
+  perm3->column(0) = unitVec[1];
+  perm3->column(1) = unitVec[2];
+  perm3->column(2) = unitVec[0];
+
+  perm4 = new RealSpaceMatrix();
+  perm4->column(0) = unitVec[2];
+  perm4->column(1) = unitVec[1];
+  perm4->column(2) = unitVec[0];
+
+  perm5 = new RealSpaceMatrix();
+  perm5->column(0) = unitVec[2];
+  perm5->column(1) = unitVec[0];
+  perm5->column(2) = unitVec[1];
+
+}
+void MatrixUnittest::tearDown(){
+  delete zero;
+  delete one;
+  delete full;
+  delete diagonal;
+  delete perm1;
+  delete perm2;
+  delete perm3;
+  delete perm4;
+  delete perm5;
+}
+
+void MatrixUnittest::AccessTest(){
+  RealSpaceMatrix mat;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),0.);
+    }
+  }
+  int k=1;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      mat.at(i,j)=k++;
+    }
+  }
+  k=1;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),(double)k);
+      ++k;
+    }
+  }
+}
+
+void MatrixUnittest::VectorTest(){
+  RealSpaceMatrix mat;
+  for(int i=NDIM;i--;){
+    CPPUNIT_ASSERT_EQUAL(mat.row(i),zeroVec);
+    CPPUNIT_ASSERT_EQUAL(mat.column(i),zeroVec);
+  }
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),zeroVec);
+
+  mat.setIdentity();
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),unitVec[2]);
+
+  Vector t1=Vector(1.,1.,1.);
+  Vector t2=Vector(2.,2.,2.);
+  Vector t3=Vector(3.,3.,3.);
+  Vector t4=Vector(1.,2.,3.);
+
+  mat.row(0)=t1;
+  mat.row(1)=t2;
+  mat.row(2)=t3;
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),t1);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),t2);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),t3);
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),i+1.);
+    }
+  }
+
+  mat.column(0)=t1;
+  mat.column(1)=t2;
+  mat.column(2)=t3;
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),t1);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),t2);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),t3);
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),j+1.);
+    }
+  }
+}
+
+void MatrixUnittest::TransposeTest(){
+  RealSpaceMatrix res;
+
+  // transpose of unit is unit
+  res.setIdentity();
+  res.transpose();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+
+  // transpose of transpose is same matrix
+  res.setZero();
+  res.set(2,2, 1.);
+  CPPUNIT_ASSERT_EQUAL(res.transpose().transpose(),res);
+}
+
+void MatrixUnittest::OperationTest(){
+  RealSpaceMatrix res;
+
+  res =(*zero) *(*zero);
+  std::cout << *zero << " times " << *zero << " is " << res << std::endl;
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*one);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*full);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*diagonal);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+
+  res =(*one)*(*one);
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res =(*one)*(*full);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res =(*one)*(*diagonal);
+  CPPUNIT_ASSERT_EQUAL(res,*diagonal);
+  res =(*one)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*perm1);
+  res =(*one)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*perm2);
+  res =(*one)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*perm3);
+  res =(*one)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*perm4);
+  res =(*one)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*perm5);
+
+  res = (*full)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+
+  res = (*diagonal)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),3*unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),2*unitVec[1]);
+  res = (*diagonal)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),2*unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),3*unitVec[2]);
+  res = (*diagonal)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),2*unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),3*unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),unitVec[0]);
+  res = (*diagonal)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),3*unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),2*unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),unitVec[0]);
+  res = (*diagonal)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),3*unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),2*unitVec[1]);
+}
+
+void MatrixUnittest::RotationTest(){
+  RealSpaceMatrix res;
+  RealSpaceMatrix inverse;
+
+  // zero rotation angles yields unity matrix
+  res.setRotation(0,0,0);
+  CPPUNIT_ASSERT_EQUAL(*one, res);
+
+  // arbitrary rotation matrix has det = 1
+  res.setRotation(M_PI/3.,1.,M_PI/7.);
+  CPPUNIT_ASSERT(fabs(fabs(res.determinant()) -1.) < MYEPSILON);
+
+  // inverse is rotation matrix with negative angles
+  res.setRotation(M_PI/3.,0.,0.);
+  inverse.setRotation(-M_PI/3.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL(*one, res * inverse);
+
+  // ... or transposed
+  res.setRotation(M_PI/3.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL(inverse, ((const RealSpaceMatrix) res).transpose());
+}
+
+void MatrixUnittest::InvertTest(){
+  CPPUNIT_ASSERT_THROW(zero->invert(),NotInvertibleException);
+  CPPUNIT_ASSERT_THROW(full->invert(),NotInvertibleException);
+
+  RealSpaceMatrix res;
+  res = (*one)*one->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*diagonal)*diagonal->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm1)*perm1->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm2)*perm2->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm3)*perm3->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm4)*perm4->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm5)*perm5->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+}
+
+
+void MatrixUnittest::DeterminantTest(){
+  CPPUNIT_ASSERT_EQUAL(zero->determinant(),0.);
+  CPPUNIT_ASSERT_EQUAL(one->determinant(),1.);
+  CPPUNIT_ASSERT_EQUAL(diagonal->determinant(),6.);
+  CPPUNIT_ASSERT_EQUAL(full->determinant(),0.);
+  CPPUNIT_ASSERT_EQUAL(perm1->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm2->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm3->determinant(),1.);
+  CPPUNIT_ASSERT_EQUAL(perm4->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm5->determinant(),1.);
+}
+
+void MatrixUnittest::VecMultTest(){
+  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[0],zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[1],zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[2],zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[0],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[1],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[2],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*one)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[0],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[1],2*unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[2],3*unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[0],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[1],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[2],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[0],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[1],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[2],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[0],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[1],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[2],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[0],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[1],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[2],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[0],unitVec[2]);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[1],unitVec[0]);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[2],unitVec[1]);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*zeroVec,zeroVec);
+
+  Vector t = Vector(1.,2.,3.);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*t,Vector(1,3,2));
+  CPPUNIT_ASSERT_EQUAL((*perm2)*t,Vector(2,1,3));
+  CPPUNIT_ASSERT_EQUAL((*perm3)*t,Vector(3,1,2));
+  CPPUNIT_ASSERT_EQUAL((*perm4)*t,Vector(3,2,1));
+  CPPUNIT_ASSERT_EQUAL((*perm5)*t,Vector(2,3,1));
+}
Index: src/LinearAlgebra/unittests/MatrixUnitTest.hpp
===================================================================
--- src/LinearAlgebra/unittests/MatrixUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
+++ src/LinearAlgebra/unittests/MatrixUnitTest.hpp	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -0,0 +1,52 @@
+/*
+ * MatrixUnitTest.hpp
+ *
+ *  Created on: Jul 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef MATRIXUNITTEST_HPP_
+#define MATRIXUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class RealSpaceMatrix;
+
+class MatrixUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( MatrixUnittest) ;
+  CPPUNIT_TEST ( AccessTest );
+  CPPUNIT_TEST ( VectorTest );
+  CPPUNIT_TEST ( OperationTest );
+  CPPUNIT_TEST ( TransposeTest );
+  CPPUNIT_TEST ( RotationTest );
+  CPPUNIT_TEST ( InvertTest );
+  CPPUNIT_TEST ( DeterminantTest );
+  CPPUNIT_TEST ( VecMultTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void AccessTest();
+  void VectorTest();
+  void OperationTest();
+  void TransposeTest();
+  void RotationTest();
+  void InvertTest();
+  void DeterminantTest();
+  void VecMultTest();
+
+  RealSpaceMatrix *zero;
+  RealSpaceMatrix *one;
+  RealSpaceMatrix *full;
+  RealSpaceMatrix *diagonal;
+  RealSpaceMatrix *perm1;
+  RealSpaceMatrix *perm2;
+  RealSpaceMatrix *perm3;
+  RealSpaceMatrix *perm4;
+  RealSpaceMatrix *perm5;
+};
+
+#endif /* MATRIXUNITTEST_HPP_ */
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ src/unittests/Makefile.am	(revision fff54fc0db0a4acc85e41914d8ef5c4e74bd0e7f)
@@ -5,4 +5,6 @@
 	../Actions/unittests \
 	../Descriptors/unittests \
+	../Helpers/unittests \
+	../LinearAlgebra/unittests \
 	../Patterns/unittests
 
@@ -22,5 +24,4 @@
   CountBondsUnitTest \
   FormulaUnittest \
-  InfoUnitTest \
   LinearSystemOfEquationsUnitTest \
   LineUnittest \
@@ -29,7 +30,4 @@
   LogUnitTest \
   manipulateAtomsTest \
-  MatrixContentSymmetricUnitTest \
-  MatrixContentUnitTest \
-  MatrixUnittest \
   MenuDescriptionUnitTest \
   MoleculeDescriptorTest \
@@ -82,5 +80,5 @@
   CountBondsUnitTest.cpp \
   FormulaUnittest.cpp \
-  infounittest.cpp \
+  ../Helpers/unittests/InfoUnitTest.cpp \
   linearsystemofequationsunittest.cpp \
   LineUnittest.cpp \
@@ -88,7 +86,7 @@
   listofbondsunittest.cpp \
   logunittest.cpp \
-  MatrixContentSymmetricUnittest.cpp \
-  MatrixContentUnittest.cpp \
-  MatrixUnittest.cpp \
+  ../LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.cpp \
+  ../LinearAlgebra/unittests/MatrixContentUnitTest.cpp \
+  ../LinearAlgebra/unittests/MatrixUnitTest.cpp \
   manipulateAtomsTest.cpp \
   MenuDescriptionUnitTest.cpp \
@@ -122,5 +120,5 @@
   CountBondsUnitTest.hpp \
   FormulaUnittest.hpp \
-  infounittest.hpp \
+  ../Helpers/unittests/InfoUnitTest.h00pp \
   linearsystemofequationsunittest.hpp \
   LineUnittest.hpp \
@@ -129,7 +127,7 @@
   logunittest.hpp \
   manipulateAtomsTest.hpp \
-  MatrixContentSymmetricUnittest.hpp \
-  MatrixContentUnittest.hpp \
-  MatrixUnittest.hpp \
+  ../LinearAlgebra/unittests/MatrixContentSymmetricUnitTest.hpp \
+  ../LinearAlgebra/unittests/MatrixContentUnitTest.hpp \
+  ../LinearAlgebra/unittests/MatrixUnitTest.hpp \
   MenuDescriptionUnitTest.hpp \
   MoleculeDescriptorTest.hpp \
@@ -174,13 +172,4 @@
 FormulaUnittest_LDADD = ${ALLLIBS}
 
-MatrixContentSymmetricUnitTest_SOURCES = UnitTestMain.cpp MatrixContentSymmetricUnittest.cpp MatrixContentSymmetricUnittest
-MatrixContentSymmetricUnitTest_LDADD = ${ALLLIBS}
-
-MatrixContentUnitTest_SOURCES = UnitTestMain.cpp MatrixContentUnittest.cpp MatrixContentUnittest.hpp
-MatrixContentUnitTest_LDADD = ${ALLLIBS}
-
-InfoUnitTest_SOURCES = UnitTestMain.cpp infounittest.cpp infounittest.hpp
-InfoUnitTest_LDADD = ${ALLLIBS}
-
 LinearSystemOfEquationsUnitTest_SOURCES = UnitTestMain.cpp linearsystemofequationsunittest.cpp linearsystemofequationsunittest.hpp
 LinearSystemOfEquationsUnitTest_LDADD = ${ALLLIBS}
@@ -201,7 +190,4 @@
 manipulateAtomsTest_LDADD = ${UILIBS} ${ALLLIBS}
 
-MatrixUnittest_SOURCES = UnitTestMain.cpp MatrixUnittest.cpp MatrixUnittest.hpp
-MatrixUnittest_LDADD = ${ALLLIBS}
-
 MenuDescriptionUnitTest_SOURCES = UnitTestMain.cpp MenuDescriptionUnitTest.cpp   MenuDescriptionUnitTest.hpp
 MenuDescriptionUnitTest_LDADD = ${ALLLIBS}
Index: c/unittests/MatrixContentSymmetricUnittest.cpp
===================================================================
--- src/unittests/MatrixContentSymmetricUnittest.cpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,285 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * MatrixContentSymmetricUnittest.cpp
- *
- *  Created on: Jan 8, 2010
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include "MatrixContentSymmetricUnittest.hpp"
-
-#include "LinearAlgebra/MatrixContent.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( MatrixContentSymmetricTest );
-
-
-void MatrixContentSymmetricTest::setUp()
-{
-  m = new MatrixContent(3,3);
-};
-
-void MatrixContentSymmetricTest::tearDown()
-{
-  delete(m);
-};
-
-/** Unit Test for accessing matrix elements.
- *
- */
-void MatrixContentSymmetricTest::AccessTest()
-{
-  // check whether all elements are initially zero
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
-
-  // set
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i*3+j );
-
-  // and check
-  double *ptr = NULL;
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++) {
-      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->at(i,j) );
-      ptr = m->Pointer(i,j);
-      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
-    }
-
-  // assignment
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i*3+j );
-  MatrixContent *dest = new MatrixContent(3,3);
-  *dest = *m;
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( dest->at(i,j), m->at(i,j) );
-  delete(dest);
-
-  // out of bounds
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(4,2) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(2,17) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(1024,140040) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,0) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(0,-1) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,-1) );
-};
-
-/** Unit Test for initializating matrices.
- *
- */
-void MatrixContentSymmetricTest::InitializationTest()
-{
-  // set zero
-  m->setZero();
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
-
-  // set all
-  m->setValue(1.5);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 1.5, m->at(i,j) );
-
-  // set basis
-  m->setIdentity();
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
-
-  // set from array
-  double array[] = { 1., 0., 0.,
-                     0., 1., 0.,
-                     0., 0., 1. };
-  m->setFromDoubleArray(array);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
-
-};
-
-/** Unit Test for copying matrices.
- *
- */
-void MatrixContentSymmetricTest::CopyTest()
-{
-  // set basis
-  MatrixContent *dest = NULL;
-  for (int i=0;i<3;i++) {
-    m->setValue(i);
-    dest = new MatrixContent(m);
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( m->at(i,j) , dest->at(i,j) );
-
-    delete(dest);
-  }
-};
-
-/** Unit Test for exchanging rows and columns.
- *
- */
-void MatrixContentSymmetricTest::ExchangeTest()
-{
-  // set to 1,1,1,2, ...
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i+1 );
-
-  // swap such that nothing happens
-  m->SwapColumns(1,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
-
-  // swap two rows
-  m->SwapRows(1,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      switch (j) {
-        case 0:
-          CPPUNIT_ASSERT_EQUAL( 1., m->at(j,i) );
-          break;
-        case 1:
-          CPPUNIT_ASSERT_EQUAL( 3., m->at(j,i) );
-          break;
-        case 2:
-          CPPUNIT_ASSERT_EQUAL( 2., m->at(j,i) );
-          break;
-        default:
-          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
-      }
-  // check that op is reversable
-  m->SwapRows(1,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
-
-  // set to 1,2,3,1, ...
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, j+1. );
-
-  // swap such that nothing happens
-  m->SwapRows(0,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
-
-  // swap two columns
-  m->SwapColumns(0,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      switch (j) {
-        case 0:
-          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
-          break;
-        case 1:
-          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
-          break;
-        case 2:
-          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
-          break;
-        default:
-          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
-      }
-  // check that op is reversable
-  m->SwapColumns(0,2);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
-
-
-  // set to 1,2,3, ...
-  MatrixContent *n =  new MatrixContent(3,3);
-  for (int i=0;i<3;i++)
-    for (int j=0;j<3;j++) {
-      m->set(i,j, 3*i+j+1 );
-      n->set(i,j, 3*j+i+1 );
-    }
-  // transpose
-  MatrixContent res = ((const MatrixContent)*m).transpose();
-  CPPUNIT_ASSERT( *n == res );
-  // second transpose
-  res.transpose();
-  CPPUNIT_ASSERT( *m == res );
-  delete n;
-};
-
-/** Unit Test for matrix properties.
- *
- */
-void MatrixContentSymmetricTest::PropertiesTest()
-{
-  // is zero
-  m->setZero();
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
-
-  // is positive
-  m->setValue(0.5);
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
-
-  // is negative
-  m->setValue(-0.1);
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
-
-  // is positive definite
-  double array[] = { 1., 0., 0.,
-                     0., 1., 1.,
-                     0., 0., 1. };
-  m->setFromDoubleArray(array);
-  CPPUNIT_ASSERT_EQUAL( true, m->IsPositiveDefinite() );
-
-  //determinant
-  m->setIdentity();
-  CPPUNIT_ASSERT_EQUAL( 1., m->Determinant() );
-
-  m->setZero();
-  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
-
-  m->set( 0, 0, 1.);
-  m->set( 1, 1, 1.);
-  m->set( 2, 1, 1.);
-  CPPUNIT_ASSERT_EQUAL( 0., m->Determinant() );
-  
-  double array2[] = { 2., 0., 1.,
-                     -3., 1., 1.,
-                     1., 5.5, 1. };
-  m->setFromDoubleArray(array2);
-  CPPUNIT_ASSERT_EQUAL( -26.5, m->Determinant() );
-};
Index: c/unittests/MatrixContentSymmetricUnittest.hpp
===================================================================
--- src/unittests/MatrixContentSymmetricUnittest.hpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,42 +1,0 @@
-/*
- * MatrixContentSymmetricUnittest.hpp
- *
- *  Created on: Jan 8, 2010
- *      Author: heber
- */
-
-#ifndef MATRIXCONTENTSYMMETRICUNITTEST_HPP_
-#define MATRIXCONTENTSYMMETRICUNITTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-class MatrixContent;
-
-/********************************************** Test classes **************************************/
-
-class MatrixContentSymmetricTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( MatrixContentSymmetricTest) ;
-    CPPUNIT_TEST (AccessTest );
-    CPPUNIT_TEST (InitializationTest );
-    CPPUNIT_TEST (CopyTest );
-    CPPUNIT_TEST (ExchangeTest );
-    CPPUNIT_TEST (PropertiesTest );
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-    void setUp();
-    void tearDown();
-
-    void AccessTest();
-    void InitializationTest();
-    void CopyTest();
-    void ExchangeTest();
-    void PropertiesTest();
-
-private:
-    MatrixContent *m;
-};
-
-
-#endif /* MATRIXCONTENTSYMMETRICUNITTEST_HPP_ */
Index: c/unittests/MatrixContentUnittest.cpp
===================================================================
--- src/unittests/MatrixContentUnittest.cpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,267 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * MatrixContentUnittest.cpp
- *
- *  Created on: Jan 8, 2010
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include "MatrixContentUnittest.hpp"
-
-#include "LinearAlgebra/MatrixContent.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( MatrixContentTest );
-
-
-void MatrixContentTest::setUp()
-{
-  m = new MatrixContent(4,3);
-};
-
-void MatrixContentTest::tearDown()
-{
-  delete(m);
-};
-
-/** Unit Test for accessing matrix elements.
- *
- */
-void MatrixContentTest::AccessTest()
-{
-  // check whether all elements are initially zero
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
-
-  // set
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i*3+j );
-
-  // and check
-  double *ptr = NULL;
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++) {
-      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), m->at(i,j) );
-      ptr = m->Pointer(i,j);
-      CPPUNIT_ASSERT_EQUAL( (double)(i*3+j), *ptr );
-    }
-
-  // assignment
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i*3+j );
-  MatrixContent *dest = new MatrixContent(4,3);
-  *dest = *m;
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( dest->at(i,j), m->at(i,j) );
-  delete(dest);
-
-  // out of bounds
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(5,2) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(2,17) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(1024,140040) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,0) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(0,-1) );
-  //CPPUNIT_ASSERT_EQUAL(0., v->at(-1,-1) );
-};
-
-/** Unit Test for initializating matrices.
- *
- */
-void MatrixContentTest::InitializationTest()
-{
-  // set zero
-  m->setZero();
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 0., m->at(i,j) );
-
-  // set all
-  m->setValue(1.5);
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( 1.5, m->at(i,j) );
-
-  // set basis
-  m->setIdentity();
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
-
-  // set from array
-  double array[] = { 1., 0., 0.,
-                     0., 1., 0.,
-                     0., 0., 1.,
-                     0., 0., 0. };
-  m->setFromDoubleArray(array);
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( i == j ? 1. : 0. , m->at(i,j) );
-
-};
-
-/** Unit Test for copying matrices.
- *
- */
-void MatrixContentTest::CopyTest()
-{
-  // set basis
-  MatrixContent *dest = NULL;
-  for (int i=0;i<4;i++) {
-    m->setValue(i);
-    dest = new MatrixContent(m);
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( m->at(i,j) , dest->at(i,j) );
-
-    delete(dest);
-  }
-};
-
-/** Unit Test for exchanging rows and columns.
- *
- */
-void MatrixContentTest::ExchangeTest()
-{
-  // set to 1,1,1,2, ...
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, i+1 );
-
-  // swap such that nothing happens
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(1,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
-
-  // swap two rows
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      switch (i) {
-        case 0:
-          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
-          break;
-        case 1:
-          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
-          break;
-        case 2:
-          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
-          break;
-        case 3:
-          CPPUNIT_ASSERT_EQUAL( 4., m->at(i,j) );
-          break;
-        default:
-          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
-      }
-  // check that op is reversable
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(1,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)i+1., m->at(i,j) );
-
-  // set to 1,2,3,1, ...
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      m->set(i,j, j+1. );
-
-  // swap such that nothing happens
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapRows(0,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
-
-  // swap two columns
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      switch (j) {
-        case 0:
-          CPPUNIT_ASSERT_EQUAL( 3., m->at(i,j) );
-          break;
-        case 1:
-          CPPUNIT_ASSERT_EQUAL( 2., m->at(i,j) );
-          break;
-        case 2:
-          CPPUNIT_ASSERT_EQUAL( 1., m->at(i,j) );
-          break;
-        default:
-          CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
-      }
-  // check that op is reversable
-  CPPUNIT_ASSERT_EQUAL( true, m->SwapColumns(0,2) );
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++)
-      CPPUNIT_ASSERT_EQUAL( (double)j+1., m->at(i,j) );
-
-
-  // set to 1,2,3,4, ...
-  MatrixContent *n =  new MatrixContent(3,4);
-  for (int i=0;i<4;i++)
-    for (int j=0;j<3;j++) {
-      m->set(i,j, 3*i+j+1 );
-      n->set(j,i, 3*i+j+1 );
-    }
-  // transpose
-  MatrixContent res = ((const MatrixContent)(*m)).transpose();
-  CPPUNIT_ASSERT( *n == res );
-  // second transpose
-  MatrixContent res2 = ((const MatrixContent)res).transpose();
-  CPPUNIT_ASSERT( *m == res2 );
-  delete n;
-};
-
-/** Unit Test for matrix properties.
- *
- */
-void MatrixContentTest::PropertiesTest()
-{
-  // is zero
-  m->setZero();
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
-
-  // is positive
-  m->setValue(0.5);
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNonNegative() );
-
-  // is negative
-  m->setValue(-0.1);
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNull() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsPositive() );
-  CPPUNIT_ASSERT_EQUAL( true, m->IsNegative() );
-  CPPUNIT_ASSERT_EQUAL( false, m->IsNonNegative() );
-
-  // is positive definite
-  CPPUNIT_ASSERT_EQUAL( false, m->IsPositiveDefinite() );
-};
Index: c/unittests/MatrixContentUnittest.hpp
===================================================================
--- src/unittests/MatrixContentUnittest.hpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,42 +1,0 @@
-/*
- * MatrixContentUnittest.hpp
- *
- *  Created on: Jan 8, 2010
- *      Author: heber
- */
-
-#ifndef MATRIXCONTENTUNITTEST_HPP_
-#define MATRIXCONTENTUNITTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-class MatrixContent;
-
-/********************************************** Test classes **************************************/
-
-class MatrixContentTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( MatrixContentTest) ;
-    CPPUNIT_TEST (AccessTest );
-    CPPUNIT_TEST (InitializationTest );
-    CPPUNIT_TEST (CopyTest );
-    CPPUNIT_TEST (ExchangeTest );
-    CPPUNIT_TEST (PropertiesTest );
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-    void setUp();
-    void tearDown();
-
-    void AccessTest();
-    void InitializationTest();
-    void CopyTest();
-    void ExchangeTest();
-    void PropertiesTest();
-
-private:
-    MatrixContent *m;
-};
-
-
-#endif /* MATRIXCONTENTUNITTEST_HPP_ */
Index: c/unittests/MatrixUnittest.cpp
===================================================================
--- src/unittests/MatrixUnittest.cpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,364 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * MatrixUnittest.cpp
- *
- *  Created on: Jul 7, 2010
- *      Author: crueger
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include <cmath>
-
-#include "MatrixUnittest.hpp"
-#include "LinearAlgebra/Vector.hpp"
-#include "LinearAlgebra/RealSpaceMatrix.hpp"
-#include "Exceptions/NotInvertibleException.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( MatrixUnittest );
-
-void MatrixUnittest::setUp(){
-  zero = new RealSpaceMatrix();
-  for(int i =NDIM;i--;) {
-    for(int j =NDIM;j--;) {
-      zero->at(i,j)=0.;
-    }
-  }
-  one = new RealSpaceMatrix();
-  for(int i =NDIM;i--;){
-    one->at(i,i)=1.;
-  }
-  full=new RealSpaceMatrix();
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      full->at(i,j)=1.;
-    }
-  }
-  diagonal = new RealSpaceMatrix();
-  for(int i=NDIM;i--;){
-    diagonal->at(i,i)=i+1.;
-  }
-  perm1 = new RealSpaceMatrix();
-  perm1->column(0) = unitVec[0];
-  perm1->column(1) = unitVec[2];
-  perm1->column(2) = unitVec[1];
-
-
-  perm2 = new RealSpaceMatrix();
-  perm2->column(0) = unitVec[1];
-  perm2->column(1) = unitVec[0];
-  perm2->column(2) = unitVec[2];
-
-  perm3 = new RealSpaceMatrix();
-  perm3->column(0) = unitVec[1];
-  perm3->column(1) = unitVec[2];
-  perm3->column(2) = unitVec[0];
-
-  perm4 = new RealSpaceMatrix();
-  perm4->column(0) = unitVec[2];
-  perm4->column(1) = unitVec[1];
-  perm4->column(2) = unitVec[0];
-
-  perm5 = new RealSpaceMatrix();
-  perm5->column(0) = unitVec[2];
-  perm5->column(1) = unitVec[0];
-  perm5->column(2) = unitVec[1];
-
-}
-void MatrixUnittest::tearDown(){
-  delete zero;
-  delete one;
-  delete full;
-  delete diagonal;
-  delete perm1;
-  delete perm2;
-  delete perm3;
-  delete perm4;
-  delete perm5;
-}
-
-void MatrixUnittest::AccessTest(){
-  RealSpaceMatrix mat;
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),0.);
-    }
-  }
-  int k=1;
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      mat.at(i,j)=k++;
-    }
-  }
-  k=1;
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),(double)k);
-      ++k;
-    }
-  }
-}
-
-void MatrixUnittest::VectorTest(){
-  RealSpaceMatrix mat;
-  for(int i=NDIM;i--;){
-    CPPUNIT_ASSERT_EQUAL(mat.row(i),zeroVec);
-    CPPUNIT_ASSERT_EQUAL(mat.column(i),zeroVec);
-  }
-  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),zeroVec);
-
-  mat.setIdentity();
-  CPPUNIT_ASSERT_EQUAL(mat.row(0),unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL(mat.row(1),unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL(mat.row(2),unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL(mat.column(0),unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL(mat.column(1),unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL(mat.column(2),unitVec[2]);
-
-  Vector t1=Vector(1.,1.,1.);
-  Vector t2=Vector(2.,2.,2.);
-  Vector t3=Vector(3.,3.,3.);
-  Vector t4=Vector(1.,2.,3.);
-
-  mat.row(0)=t1;
-  mat.row(1)=t2;
-  mat.row(2)=t3;
-  CPPUNIT_ASSERT_EQUAL(mat.row(0),t1);
-  CPPUNIT_ASSERT_EQUAL(mat.row(1),t2);
-  CPPUNIT_ASSERT_EQUAL(mat.row(2),t3);
-  CPPUNIT_ASSERT_EQUAL(mat.column(0),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.column(1),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.column(2),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),i+1.);
-    }
-  }
-
-  mat.column(0)=t1;
-  mat.column(1)=t2;
-  mat.column(2)=t3;
-  CPPUNIT_ASSERT_EQUAL(mat.column(0),t1);
-  CPPUNIT_ASSERT_EQUAL(mat.column(1),t2);
-  CPPUNIT_ASSERT_EQUAL(mat.column(2),t3);
-  CPPUNIT_ASSERT_EQUAL(mat.row(0),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.row(1),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.row(2),t4);
-  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
-  for(int i=NDIM;i--;){
-    for(int j=NDIM;j--;){
-      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),j+1.);
-    }
-  }
-}
-
-void MatrixUnittest::TransposeTest(){
-  RealSpaceMatrix res;
-
-  // transpose of unit is unit
-  res.setIdentity();
-  res.transpose();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-
-  // transpose of transpose is same matrix
-  res.setZero();
-  res.set(2,2, 1.);
-  CPPUNIT_ASSERT_EQUAL(res.transpose().transpose(),res);
-}
-
-void MatrixUnittest::OperationTest(){
-  RealSpaceMatrix res;
-
-  res =(*zero) *(*zero);
-  std::cout << *zero << " times " << *zero << " is " << res << std::endl;
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*one);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*full);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*diagonal);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*perm1);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*perm2);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*perm3);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*perm4);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-  res =(*zero) *(*perm5);
-  CPPUNIT_ASSERT_EQUAL(res,*zero);
-
-  res =(*one)*(*one);
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res =(*one)*(*full);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-  res =(*one)*(*diagonal);
-  CPPUNIT_ASSERT_EQUAL(res,*diagonal);
-  res =(*one)*(*perm1);
-  CPPUNIT_ASSERT_EQUAL(res,*perm1);
-  res =(*one)*(*perm2);
-  CPPUNIT_ASSERT_EQUAL(res,*perm2);
-  res =(*one)*(*perm3);
-  CPPUNIT_ASSERT_EQUAL(res,*perm3);
-  res =(*one)*(*perm4);
-  CPPUNIT_ASSERT_EQUAL(res,*perm4);
-  res =(*one)*(*perm5);
-  CPPUNIT_ASSERT_EQUAL(res,*perm5);
-
-  res = (*full)*(*perm1);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-  res = (*full)*(*perm2);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-  res = (*full)*(*perm3);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-  res = (*full)*(*perm4);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-  res = (*full)*(*perm5);
-  CPPUNIT_ASSERT_EQUAL(res,*full);
-
-  res = (*diagonal)*(*perm1);
-  CPPUNIT_ASSERT_EQUAL(res.column(0),unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL(res.column(1),3*unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL(res.column(2),2*unitVec[1]);
-  res = (*diagonal)*(*perm2);
-  CPPUNIT_ASSERT_EQUAL(res.column(0),2*unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL(res.column(1),unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL(res.column(2),3*unitVec[2]);
-  res = (*diagonal)*(*perm3);
-  CPPUNIT_ASSERT_EQUAL(res.column(0),2*unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL(res.column(1),3*unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL(res.column(2),unitVec[0]);
-  res = (*diagonal)*(*perm4);
-  CPPUNIT_ASSERT_EQUAL(res.column(0),3*unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL(res.column(1),2*unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL(res.column(2),unitVec[0]);
-  res = (*diagonal)*(*perm5);
-  CPPUNIT_ASSERT_EQUAL(res.column(0),3*unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL(res.column(1),unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL(res.column(2),2*unitVec[1]);
-}
-
-void MatrixUnittest::RotationTest(){
-  RealSpaceMatrix res;
-  RealSpaceMatrix inverse;
-
-  // zero rotation angles yields unity matrix
-  res.setRotation(0,0,0);
-  CPPUNIT_ASSERT_EQUAL(*one, res);
-
-  // arbitrary rotation matrix has det = 1
-  res.setRotation(M_PI/3.,1.,M_PI/7.);
-  CPPUNIT_ASSERT(fabs(fabs(res.determinant()) -1.) < MYEPSILON);
-
-  // inverse is rotation matrix with negative angles
-  res.setRotation(M_PI/3.,0.,0.);
-  inverse.setRotation(-M_PI/3.,0.,0.);
-  CPPUNIT_ASSERT_EQUAL(*one, res * inverse);
-
-  // ... or transposed
-  res.setRotation(M_PI/3.,0.,0.);
-  CPPUNIT_ASSERT_EQUAL(inverse, ((const RealSpaceMatrix) res).transpose());
-}
-
-void MatrixUnittest::InvertTest(){
-  CPPUNIT_ASSERT_THROW(zero->invert(),NotInvertibleException);
-  CPPUNIT_ASSERT_THROW(full->invert(),NotInvertibleException);
-
-  RealSpaceMatrix res;
-  res = (*one)*one->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*diagonal)*diagonal->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*perm1)*perm1->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*perm2)*perm2->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*perm3)*perm3->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*perm4)*perm4->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-  res = (*perm5)*perm5->invert();
-  CPPUNIT_ASSERT_EQUAL(res,*one);
-}
-
-
-void MatrixUnittest::DeterminantTest(){
-  CPPUNIT_ASSERT_EQUAL(zero->determinant(),0.);
-  CPPUNIT_ASSERT_EQUAL(one->determinant(),1.);
-  CPPUNIT_ASSERT_EQUAL(diagonal->determinant(),6.);
-  CPPUNIT_ASSERT_EQUAL(full->determinant(),0.);
-  CPPUNIT_ASSERT_EQUAL(perm1->determinant(),-1.);
-  CPPUNIT_ASSERT_EQUAL(perm2->determinant(),-1.);
-  CPPUNIT_ASSERT_EQUAL(perm3->determinant(),1.);
-  CPPUNIT_ASSERT_EQUAL(perm4->determinant(),-1.);
-  CPPUNIT_ASSERT_EQUAL(perm5->determinant(),1.);
-}
-
-void MatrixUnittest::VecMultTest(){
-  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[0],zeroVec);
-  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[1],zeroVec);
-  CPPUNIT_ASSERT_EQUAL((*zero)*unitVec[2],zeroVec);
-  CPPUNIT_ASSERT_EQUAL((*zero)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[0],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[1],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*one)*unitVec[2],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*one)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[0],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[1],2*unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*diagonal)*unitVec[2],3*unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*diagonal)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[0],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[1],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*perm1)*unitVec[2],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*perm1)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[0],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[1],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*perm2)*unitVec[2],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*perm2)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[0],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[1],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*perm3)*unitVec[2],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*perm3)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[0],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[1],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*perm4)*unitVec[2],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*perm4)*zeroVec,zeroVec);
-
-  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[0],unitVec[2]);
-  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[1],unitVec[0]);
-  CPPUNIT_ASSERT_EQUAL((*perm5)*unitVec[2],unitVec[1]);
-  CPPUNIT_ASSERT_EQUAL((*perm5)*zeroVec,zeroVec);
-
-  Vector t = Vector(1.,2.,3.);
-  CPPUNIT_ASSERT_EQUAL((*perm1)*t,Vector(1,3,2));
-  CPPUNIT_ASSERT_EQUAL((*perm2)*t,Vector(2,1,3));
-  CPPUNIT_ASSERT_EQUAL((*perm3)*t,Vector(3,1,2));
-  CPPUNIT_ASSERT_EQUAL((*perm4)*t,Vector(3,2,1));
-  CPPUNIT_ASSERT_EQUAL((*perm5)*t,Vector(2,3,1));
-}
Index: c/unittests/MatrixUnittest.hpp
===================================================================
--- src/unittests/MatrixUnittest.hpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,52 +1,0 @@
-/*
- * MatrixUnittest.hpp
- *
- *  Created on: Jul 7, 2010
- *      Author: crueger
- */
-
-#ifndef MATRIXUNITTEST_HPP_
-#define MATRIXUNITTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-class RealSpaceMatrix;
-
-class MatrixUnittest : public CppUnit::TestFixture
-{
-  CPPUNIT_TEST_SUITE( MatrixUnittest) ;
-  CPPUNIT_TEST ( AccessTest );
-  CPPUNIT_TEST ( VectorTest );
-  CPPUNIT_TEST ( OperationTest );
-  CPPUNIT_TEST ( TransposeTest );
-  CPPUNIT_TEST ( RotationTest );
-  CPPUNIT_TEST ( InvertTest );
-  CPPUNIT_TEST ( DeterminantTest );
-  CPPUNIT_TEST ( VecMultTest );
-  CPPUNIT_TEST_SUITE_END();
-
-public:
-  void setUp();
-  void tearDown();
-
-  void AccessTest();
-  void VectorTest();
-  void OperationTest();
-  void TransposeTest();
-  void RotationTest();
-  void InvertTest();
-  void DeterminantTest();
-  void VecMultTest();
-
-  RealSpaceMatrix *zero;
-  RealSpaceMatrix *one;
-  RealSpaceMatrix *full;
-  RealSpaceMatrix *diagonal;
-  RealSpaceMatrix *perm1;
-  RealSpaceMatrix *perm2;
-  RealSpaceMatrix *perm3;
-  RealSpaceMatrix *perm4;
-  RealSpaceMatrix *perm5;
-};
-
-#endif /* MATRIXUNITTEST_HPP_ */
Index: c/unittests/infounittest.cpp
===================================================================
--- src/unittests/infounittest.cpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,62 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/*
- * InfoUnitTest.cpp
- *
- *  Created on: Nov 25, 2009
- *      Author: heber
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-using namespace std;
-
-#include <cppunit/CompilerOutputter.h>
-#include <cppunit/extensions/TestFactoryRegistry.h>
-#include <cppunit/ui/text/TestRunner.h>
-
-#include <iostream>
-#include <stdio.h>
-
-#include "Helpers/Info.hpp"
-#include "infounittest.hpp"
-#include "Helpers/Log.hpp"
-
-#ifdef HAVE_TESTRUNNER
-#include "UnitTestMain.hpp"
-#endif /*HAVE_TESTRUNNER*/
-
-/********************************************** Test classes **************************************/
-
-// Registers the fixture into the 'registry'
-CPPUNIT_TEST_SUITE_REGISTRATION( InfoTest );
-
-
-void InfoTest::setUp()
-{
-};
-
-
-void InfoTest::tearDown()
-{
-  logger::purgeInstance();
-};
-
-/** UnitTest for FunctionTest().
- */
-void InfoTest::FunctionTest()
-{
-  const char *msg = __func__;
-  class Info test(msg);
-
-  CPPUNIT_ASSERT_EQUAL( msg , test.FunctionName );
-  CPPUNIT_ASSERT_EQUAL( 1, test.verbosity );
-};
Index: c/unittests/infounittest.hpp
===================================================================
--- src/unittests/infounittest.hpp	(revision 3c8e8bb4ac545196f3097a1517f779726212885b)
+++ 	(revision )
@@ -1,32 +1,0 @@
-/*
- * InfoUnitTest.hpp
- *
- *  Created on: Nov 25, 2009
- *      Author: heber
- */
-
-#ifndef INFOUNITTEST_HPP_
-#define INFOUNITTEST_HPP_
-
-#include <cppunit/extensions/HelperMacros.h>
-
-class info;
-
-/********************************************** Test classes **************************************/
-
-class InfoTest : public CppUnit::TestFixture
-{
-    CPPUNIT_TEST_SUITE( InfoTest) ;
-    CPPUNIT_TEST ( FunctionTest );
-    CPPUNIT_TEST_SUITE_END();
-
-public:
-      void setUp();
-      void tearDown();
-      void FunctionTest();
-
-private:
-
-};
-
-#endif /* INFOUNITTEST_HPP_ */
